#include "types.h"

double SquareVec3(vec3 *v)
{
	return (v->x * v->x + v->y * v->y + v->z * v->z);
}

void SubtractVec3(vec3 *left, vec3 *right, vec3 *result)
{
	result->x = left->x - right->x;
	result->y = left->y - right->y;
	result->z = left->z - right->z;
}

void AddVec3(vec3 *left, vec3 *right, vec3 *result)
{
	result->x = left->x + right->x;
	result->y = left->y + right->y;
	result->z = left->z + right->z;
}

void ScalarMultiplayVec3(double scalar, vec3 *vec, vec3 *result)
{
	result->x = vec->x * scalar;
	result->y = vec->y * scalar;
	result->z = vec->z * scalar;
}

double DotMultiplayVec3(vec3 *left, vec3 *right)
{
	double sum = 0.0;
	sum += left->x * right->x;
	sum += left->y * right->y;
	sum += left->z * right->z;
	return sum;
}