#ifndef _TYPES_H_
#define _TYPES_H_

typedef unsigned int uint;
typedef unsigned long ulong;

typedef struct
{
	double x;
	double y;
	double z;
} vec3;

typedef struct tnode
{
	double t;
	vec3 pin;
	vec3 pout;
	vec3 q;
	struct tnode *link;
} node;

double SquareVec3(vec3 *v);
void SubtractVec3(vec3 *left, vec3 *right, vec3 *result);
void AddVec3(vec3 *left, vec3 *right, vec3 *result);
void ScalarMultiplayVec3(double scalar, vec3 *vec, vec3 *result);
double DotMultiplayVec3(vec3 *left, vec3 *right);

#endif